#pragma once

#include <stdint.h>
#include <avr/io.h>


namespace Devices::Mcu
{
    struct UsartSpi
    {
        static void Init(int divider)
        {
            DDRD |= _BV(PD4);

            UBRR0 = 0;

            UCSR0C = _BV(UMSEL01) | _BV(UMSEL00);
            UCSR0B = _BV(RXEN0) | _BV(TXEN0);

            UBRR0 = divider / 2 - 1;
        }


        static void Out(uint8_t data)
        {
            UDR0 = data;
        }


        static void WaitForDataRegisterEmpty()
        {
            while (!(UCSR0A & _BV(UDRE0)));
        }


        static void WaitForTransmitComplete()
        {
            while (!(UCSR0A & _BV(TXC0)));
        }
    };
}