#pragma once

#include <stdint.h>

namespace Devices
{
    template <class I2cImplT, uint8_t address>
    class Pcf8574
    {
        public:

            constexpr static uint8_t const ADDRESS = 0x40 | address;

            static bool Init()
            {
                I2cImplT::Init();
                return true;
            }

            static bool Out(uint8_t byte)
            {
                bool result = true;

                result = result && I2cImplT::Start(ADDRESS, I2c::Direction::Transmit);
                result = result && I2cImplT::Transmit(byte);
                result = result && I2cImplT::Stop();
                
                return result;
            }

            static bool In(uint8_t & byte)
            {
                bool result = true;

                result = result && I2cImplT::Start(ADDRESS, I2c::Direction::Receive);
                result = result && I2cImplT::Receive(byte);
                result = result && I2cImplT::Stop();
                
                return result;
            }
    };
}